summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorAzamat H. Hackimov <azamat.hackimov@gmail.com>2019-08-28 20:53:46 +0300
committerJoonas Niilola <juippis@gentoo.org>2019-12-08 10:41:05 +0200
commite163dc22eecc5f00721fa11ee1645b0079031301 (patch)
tree50a96514003df3484a5adfec20ffcc1de3fe9bef /www-apps
parentacct-user/redmine: user for www-apps/redmine (diff)
downloadgentoo-e163dc22eecc5f00721fa11ee1645b0079031301.tar.gz
gentoo-e163dc22eecc5f00721fa11ee1645b0079031301.tar.bz2
gentoo-e163dc22eecc5f00721fa11ee1645b0079031301.zip
www-apps/redmine: update to 4.0.5
Implementing GLEP81, fixes #677986 and #692890. Fixes strict dependencies and adds additional fcgi gem (#657156), fixes error with /var/log/redmine permission changes. Clear Gemfile.lock in config phase to clean up and update dependencies (#660252). Closes: https://bugs.gentoo.org/677986 Closes: https://bugs.gentoo.org/692890 Closes: https://bugs.gentoo.org/657156 Closes: https://bugs.gentoo.org/660252 Signed-off-by: Azamat H. Hackimov <azamat.hackimov@gmail.com> Package-Manager: Portage-2.3.69, Repoman-2.3.16 Signed-off-by: Joonas Niilola <juippis@gentoo.org>
Diffstat (limited to 'www-apps')
-rw-r--r--www-apps/redmine/Manifest1
-rw-r--r--www-apps/redmine/files/redmine-4.0.5_gemfile_versions.patch76
-rw-r--r--www-apps/redmine/redmine-4.0.5.ebuild224
3 files changed, 301 insertions, 0 deletions
diff --git a/www-apps/redmine/Manifest b/www-apps/redmine/Manifest
index 1aa30ff383b..684c9db78b3 100644
--- a/www-apps/redmine/Manifest
+++ b/www-apps/redmine/Manifest
@@ -1,2 +1,3 @@
DIST redmine-3.3.7.tar.gz 2371716 BLAKE2B ba1e69419f846ddfa64ddc5d26fda281737501374f5aa4f79bd4c59d5b483a28070103fcc3bf2f3b1c7a4ce96dbfb32d1d1f21a6b74603aad012ce7d2e3373ed SHA512 ba106eb60587788ccd3162274a9a40d2876324e647e1fcafce0f943d69d8fe216a01cbddb2a5a4f41f64513e287c80ec518cef5a6033b3d1ed0bcfc7d1cfcc64
DIST redmine-3.4.5.tar.gz 2448231 BLAKE2B 11041cbac5ea33c060a90ead56a4479cc86137bad5e0eb6135aed8d19059aedecd2ad52ac63ae6fcc5bbb13b5fc4cd6b05695aff484932b55ad5d7be7cb1c396 SHA512 c77ce76fadb7a2b9d6daf77a898a1ca4d7b1c8616922e89026cee3a4b0ec1a187a746f0a054b786663e78fc510596be736fd12d71b2569f6a63a21d0c95a05ad
+DIST redmine-4.0.5.tar.gz 2519900 BLAKE2B ddc465f12030f3f672ea9bf6b825fd40344dcffd3b60907a42c4dbe57f209c54a12bbd3d59f886ff000ccbd43f6d1b9c1aacfbab653f2d81bb06d8d7189bd624 SHA512 a6aa3e2418fd83ed3783fc6644c339c54ebb1952b8c2c0be4b718fb296fdff64fb4116faa2c88f3e5c3c25d7c5b3c21cd7822ff9f99f6f67270e0b8b64053678
diff --git a/www-apps/redmine/files/redmine-4.0.5_gemfile_versions.patch b/www-apps/redmine/files/redmine-4.0.5_gemfile_versions.patch
new file mode 100644
index 00000000000..46aebf2b825
--- /dev/null
+++ b/www-apps/redmine/files/redmine-4.0.5_gemfile_versions.patch
@@ -0,0 +1,76 @@
+diff -Nuar redmine-4.0.5.orig/Gemfile redmine-4.0.5/Gemfile
+--- redmine-4.0.5.orig/Gemfile 2019-10-24 22:20:32.412728804 +0300
++++ redmine-4.0.5/Gemfile 2019-10-24 22:27:40.356708042 +0300
+@@ -3,46 +3,45 @@
+ gem "bundler", ">= 1.5.0"
+
+ gem "rails", "5.2.3"
+-gem "rouge", "~> 3.3.0"
++gem "rouge", ">= 3.3.0"
+ gem "request_store", "1.0.5"
+-gem "mini_mime", "~> 1.0.1"
++gem "mini_mime", ">= 1.0.1"
+ gem "actionpack-xml_parser"
+-gem "roadie-rails", "~> 1.3.0"
++gem "roadie-rails", ">= 1.3.0"
+ gem "mimemagic"
+-gem "mail", "~> 2.7.1"
+-gem "csv", "~> 3.0.1" if RUBY_VERSION >= "2.3" && RUBY_VERSION < "2.6"
++gem "mail", ">= 2.7.1"
+
+-gem "nokogiri", (RUBY_VERSION >= "2.3" ? "~> 1.10.0" : "~> 1.9.1")
++gem "nokogiri", (RUBY_VERSION >= "2.3" ? ">= 1.10.0" : "~> 1.9.1")
+ gem "i18n", "~> 0.7.0"
+ gem "xpath", "< 3.2.0" if RUBY_VERSION < "2.3"
+
+ # TODO: Remove the following line when #32223 is fixed
+-gem "sprockets", "~> 3.7.2"
++gem "sprockets", ">= 3.7.2"
+
+ # Windows does not include zoneinfo files, so bundle the tzinfo-data gem
+ gem 'tzinfo-data', platforms: [:mingw, :x64_mingw, :mswin]
+-gem "rbpdf", "~> 1.19.6"
++gem "rbpdf", ">= 1.19.6"
+
+ # Optional gem for LDAP authentication
+ group :ldap do
+- gem "net-ldap", "~> 0.16.0"
++ gem "net-ldap", ">= 0.16.0"
+ end
+
+ # Optional gem for OpenID authentication
+ group :openid do
+- gem "ruby-openid", "~> 2.9.2", :require => "openid"
++ gem "ruby-openid", ">= 2.9.2", :require => "openid"
+ gem "rack-openid"
+ end
+
+ platforms :mri, :mingw, :x64_mingw do
+ # Optional gem for exporting the gantt to a PNG file, not supported with jruby
+ group :rmagick do
+- gem "rmagick", "~> 2.16.0"
++ gem "rmagick", ">= 2.16.0"
+ end
+
+ # Optional Markdown support, not for JRuby
+ group :markdown do
+- gem "redcarpet", "~> 3.4.0"
++ gem "redcarpet", ">= 3.4.0"
+ end
+ end
+
+@@ -58,11 +57,11 @@
+ adapters.each do |adapter|
+ case adapter
+ when 'mysql2'
+- gem "mysql2", "~> 0.5.0", :platforms => [:mri, :mingw, :x64_mingw]
++ gem "mysql2", ">= 0.5.0", :platforms => [:mri, :mingw, :x64_mingw]
+ when /postgresql/
+- gem "pg", "~> 1.1.4", :platforms => [:mri, :mingw, :x64_mingw]
++ gem "pg", ">= 1.1.4", :platforms => [:mri, :mingw, :x64_mingw]
+ when /sqlite3/
+- gem "sqlite3", "~>1.3.12", :platforms => [:mri, :mingw, :x64_mingw]
++ gem "sqlite3", ">= 1.3.12", :platforms => [:mri, :mingw, :x64_mingw]
+ when /sqlserver/
+ gem "tiny_tds", "~> 1.0.5", :platforms => [:mri, :mingw, :x64_mingw]
+ gem "activerecord-sqlserver-adapter", :platforms => [:mri, :mingw, :x64_mingw]
diff --git a/www-apps/redmine/redmine-4.0.5.ebuild b/www-apps/redmine/redmine-4.0.5.ebuild
new file mode 100644
index 00000000000..494fd300228
--- /dev/null
+++ b/www-apps/redmine/redmine-4.0.5.ebuild
@@ -0,0 +1,224 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+USE_RUBY="ruby24"
+inherit eutils depend.apache ruby-ng
+
+DESCRIPTION="Flexible project management web application using the Ruby on Rails framework"
+HOMEPAGE="https://www.redmine.org/"
+SRC_URI="https://www.redmine.org/releases/${P}.tar.gz"
+
+KEYWORDS="~amd64"
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="imagemagick fastcgi ldap markdown mysql passenger postgres sqlite"
+
+ruby_add_rdepend "
+ imagemagick? ( dev-ruby/rmagick:0 )
+ ldap? ( dev-ruby/ruby-net-ldap )
+ markdown? ( >=dev-ruby/redcarpet-3.4.0 )
+ mysql? ( >=dev-ruby/mysql2-0.5.0:0.5 )
+ postgres? ( >=dev-ruby/pg-1.1.4:1 )
+ sqlite? ( >=dev-ruby/sqlite3-1.3.12 )
+ dev-ruby/actionpack-xml_parser:*
+ dev-ruby/i18n:0.7
+ >=dev-ruby/mail-2.7.1
+ dev-ruby/mimemagic
+ >=dev-ruby/mini_mime-1.0.1
+ >=dev-ruby/nokogiri-1.10.0
+ dev-ruby/rails:5.2
+ >=dev-ruby/rbpdf-1.19.6
+ dev-ruby/request_store:1.0.5
+ >=dev-ruby/roadie-rails-1.3.0
+ >=dev-ruby/rouge-3.6.0
+ >=dev-ruby/ruby-openid-2.9.2
+ dev-ruby/rack-openid
+"
+
+RDEPEND="
+ acct-group/redmine
+ acct-user/redmine
+"
+
+REDMINE_DIR="/var/lib/${PN}"
+
+all_ruby_prepare() {
+ rm -r log files/delete.me .github || die
+
+ # bug #406605
+ rm .{git,hg}ignore || die
+
+ # newenvd not working here
+ cat > "${T}/50${PN}" <<-EOF || die
+ CONFIG_PROTECT="${EROOT%/}${REDMINE_DIR}/config"
+ CONFIG_PROTECT_MASK="${EROOT%/}${REDMINE_DIR}/config/locales ${EROOT%/}${REDMINE_DIR}/config/settings.yml"
+ EOF
+
+ # Fixing versions in Gemfile
+ eapply "${FILESDIR}/${P}_gemfile_versions.patch"
+
+ sed -i -e "/group :development do/,/end$/d" Gemfile || die
+ sed -i -e "/group :test do/,/end$/d" Gemfile || die
+
+ if ! use imagemagick ; then
+ sed -i -e "/group :rmagick do/,/end$/d" Gemfile || die
+ fi
+ if ! use ldap ; then
+ # remove ldap stuff module if disabled to avoid #413779
+ use ldap || rm app/models/auth_source_ldap.rb || die
+ sed -i -e "/group :ldap do/,/end$/d" Gemfile || die
+ fi
+ if ! use markdown ; then
+ sed -i -e "/group :markdown do/,/end$/d" Gemfile || die
+ fi
+}
+
+all_ruby_install() {
+ dodoc doc/* README.rdoc
+ rm -r doc appveyor.yml CONTRIBUTING.md README.rdoc || die
+
+ keepdir /var/log/${PN}
+
+ # Additional dependency for Gemfile (#657156)
+ if use fastcgi; then
+ echo "gem \"fcgi\"" > Gemfile.local
+ fi
+
+ insinto "${REDMINE_DIR}"
+ doins -r .
+ insinto "${REDMINE_DIR}/config"
+ doins "${FILESDIR}/additional_environment.rb"
+ keepdir "${REDMINE_DIR}/files"
+ keepdir "${REDMINE_DIR}/public/plugin_assets"
+
+ fowners -R redmine:redmine \
+ "${REDMINE_DIR}/config" \
+ "${REDMINE_DIR}/files" \
+ "${REDMINE_DIR}/public/plugin_assets" \
+ "${REDMINE_DIR}/tmp" \
+ /var/log/${PN}
+
+ fowners redmine:redmine "${REDMINE_DIR}"
+
+ # protect sensitive data, see bug #406605
+ fperms -R go-rwx \
+ "${REDMINE_DIR}/config" \
+ "${REDMINE_DIR}/files" \
+ "${REDMINE_DIR}/tmp" \
+ /var/log/${PN}
+
+ if use passenger; then
+ has_apache
+ insinto "${APACHE_VHOSTS_CONFDIR}"
+ doins "${FILESDIR}/10_redmine_vhost.conf"
+ fi
+
+ # logrotate
+ insinto /etc/logrotate.d
+ newins "${FILESDIR}"/redmine.logrotate redmine
+
+ newconfd "${FILESDIR}/${PN}.confd" ${PN}
+ newinitd "${FILESDIR}/${PN}-3.initd" ${PN}
+ doenvd "${T}/50${PN}"
+}
+
+pkg_postinst() {
+ if [[ -e "${EROOT%/}${REDMINE_DIR}/config/initializers/session_store.rb" \
+ || -e "${EROOT%/}${REDMINE_DIR}/config/initializers/secret_token.rb" ]]
+ then
+ elog "Execute the following command to upgrade environment:"
+ elog
+ elog "# emerge --config \"=${CATEGORY}/${PF}\""
+ elog
+ elog "For upgrade instructions take a look at:"
+ elog "http://www.redmine.org/wiki/redmine/RedmineUpgrade"
+ else
+ elog "Execute the following command to initialize environment:"
+ elog
+ elog "# cd ${EROOT%/}${REDMINE_DIR}"
+ elog "# cp config/database.yml.example config/database.yml"
+ elog "# \${EDITOR} config/database.yml"
+ elog "# chown redmine:redmine config/database.yml"
+ elog "# emerge --config \"=${CATEGORY}/${PF}\""
+ elog
+ elog "Installation notes are at official site"
+ elog "http://www.redmine.org/wiki/redmine/RedmineInstall"
+ fi
+}
+
+pkg_config() {
+ # Remove old lock file
+ rm -f "${EROOT%/}${REDMINE_DIR}/Gemfile.lock"
+
+ if [[ ! -e "${EROOT%/}${REDMINE_DIR}/config/database.yml" ]]; then
+ eerror "Copy ${EROOT%/}${REDMINE_DIR}/config/database.yml.example to"
+ eerror "${EROOT%/}${REDMINE_DIR}/config/database.yml then edit this"
+ eerror "file in order to configure your database settings for"
+ eerror "\"production\" environment."
+ die
+ fi
+
+ local RAILS_ENV=${RAILS_ENV:-production}
+ if [[ ! -L /usr/bin/ruby ]]; then
+ eerror "/usr/bin/ruby is not a valid symlink to any ruby implementation."
+ eerror "Please update it via `eselect ruby`"
+ die
+ fi
+ if [[ $RUBY_TARGETS != *$( eselect ruby show | awk 'NR==2' | tr -d ' ' )* ]]
+ then
+ eerror "/usr/bin/ruby is currently not included in redmine's ruby targets:"
+ eerror "${RUBY_TARGETS}."
+ eerror "Please update it via `eselect ruby`"
+ die
+ fi
+ local RUBY=${RUBY:-ruby}
+
+ cd "${EROOT%/}${REDMINE_DIR}" || die
+ if [[ -e "${EROOT%/}${REDMINE_DIR}/config/initializers/session_store.rb" ]]
+ then
+ einfo
+ einfo "Generating secret token."
+ einfo
+ rm config/initializers/session_store.rb || die
+ RAILS_ENV="${RAILS_ENV}" ${RUBY} -S rake generate_secret_token || die
+ fi
+ if [[ -e "${EROOT%/}${REDMINE_DIR}/config/initializers/secret_token.rb" ]]
+ then
+ einfo
+ einfo "Upgrading database."
+ einfo
+
+ einfo "Generating secret token."
+ # Migration from Redmine 2.x
+ rm config/initializers/secret_token.rb || die
+ RAILS_ENV="${RAILS_ENV}" ${RUBY} -S rake generate_secret_token || die
+
+ einfo "Migrating database."
+ RAILS_ENV="${RAILS_ENV}" ${RUBY} -S rake db:migrate || die
+ einfo "Upgrading the plugin migrations."
+ RAILS_ENV="${RAILS_ENV}" ${RUBY} -S rake redmine:plugins:migrate || die
+ einfo "Clear the cache."
+ ${RUBY} -S rake tmp:cache:clear || die
+ else
+ einfo
+ einfo "Initializing database."
+ einfo
+
+ einfo "Generating a session store secret."
+ ${RUBY} -S rake generate_secret_token || die
+ einfo "Creating the database structure."
+ RAILS_ENV="${RAILS_ENV}" ${RUBY} -S rake db:migrate || die
+ einfo "Populating database with default configuration data."
+ RAILS_ENV="${RAILS_ENV}" ${RUBY} -S rake redmine:load_default_data || die
+ chown redmine:redmine -R "${EROOT%/}/var/log/redmine/" || die
+ einfo
+ einfo "If you use sqlite3, please do not forget to change the ownership"
+ einfo "of the sqlite files."
+ einfo
+ einfo "# cd \"${EROOT%/}${REDMINE_DIR}\""
+ einfo "# chown redmine:redmine db/ db/*.sqlite3"
+ einfo
+ fi
+}